#include <Arduboy2.h>
Arduboy2 arduboy;

#define LINKS             0
#define RECHTS            1
#define RAUF              2
#define RUNTER            3
#define KOLLISION         4
#define KEINE_KOLLISION   5
#define KEINE_KONTROLLE   6

#define DISPLAY_HOEHE     128
#define DISPLAY_BREITE    64

#define BALL_BREITE       16
#define BALL_HOEHE        16

#define ZEICHNUNG(n)  const unsigned char n[] PROGMEM   

// **********************************************
// Speicher - für den Ball
// **********************************************
ZEICHNUNG(Ball) = {
0xe0, 0x10, 0x0c, 0x04, 0x02, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x02, 0x04, 0xc, 0x30, 0xc0, 0x07, 0x08, 0x30, 0x20, 0x40, 0x40, 0x80, 0x80, 0x80, 0x80, 0x40, 0x40, 0x20, 0x30, 0x0c, 0x03
};

// **********************************************
// Speicher - richtung vom Ball
// **********************************************
int richtung;

// **********************************************
// Position vom Ball
// **********************************************
int bx;
int by;

// **********************************************
// Start des Programmes.
// Wird nur einmal abgearbeitet.
// **********************************************
void setup()
{
  // Richtung vom Ball beim Start
  // Der Ball fliegt nach rechts
  richtung = RECHTS;
  
  // Position vom Ball
  // Startposition ist links, etwas gegen die Mitte
  bx = 0;
  by = 20;

  arduboy.begin();
  arduboy.clear();
}


// **********************************************
// Unsere Endlosschleife - START
// **********************************************
void loop()
{
  if ( arduboy.nextFrame() )
  {
    // **********************************************
    // Das Display löschen - Alles Schwarz
    // **********************************************
    arduboy.clear();

    // **********************************************
    // Regeln
    // **********************************************
    Ball_Regeln();

    // **********************************************
    // Nun das gezeichnete auf's Display kopieren.
    // **********************************************
    arduboy.display();
  }
}
// **********************************************
// Unsere Endlosschleife - ENDE
// **********************************************


// **********************************************
// Das Zeichnen des Ball's mit den Regeln - START
// **********************************************
void Ball_Regeln ()
{
  // **********************************************
  // Regel - Ball fliegt nach rechts
  // **********************************************
  if ( richtung == RECHTS )
  {
    // Wurde der rechte Rand erreicht?
    if ( (DISPLAY_BREITE - BALL_BREITE) > bx )
    { // Der rechte Rand wurde nicht erreicht
      bx = bx + 1;
    }
    else
    {
      richtung = LINKS;
    }
  }

  // **********************************************
  // Regel - Ball fliegt nach links
  // **********************************************
  if ( richtung == LINKS )
  {
    // Wurde der linke Rand erreicht?
    if ( bx > 0 )
    { // Der linke Rand wurde nicht erreicht
      bx = bx - 1;
    }
    else
    { // Linker Rand ist erreicht, jetzt die Richtung wechseln
      richtung = RECHTS;
    }
  }

}
// **********************************************
// Das Zeichnen des Ball's mit den Regeln - ENDE
// **********************************************

